#multiSearch.py
############################################################################
#    External method EventFolder/Extensions/multiSearch.py
#    Ver 1.0  Aug 1 2000
#
#    License follows the Zope license, & use at your own risk
#    written and Copyright by Jeff Sasmor  (jeff@sasmor.com)
#
#############################################################################

import string

#############################################################################
#    xSearch does a catalog search for using a 
#    dictionary of invariant parameters and a
#    list of dictionaries of variant parameters.
#    It also has a maximum # of return values, useful
#	 since the search results are kept in memory. A
#    useful value might be 50 to 100. 
#    the moderated param should be 'on' to filter out unreviewed items if 
#    the event log is moderated 
#
#    For example: you might have invariant search parameters like:
#    {meta_type:'someMetaType',spam:'eggs'} and so on.
#
#    You might also have search terms that require multiple searches
#    in order to make up a result set.  For example:
#    { 'text_content':search_term} and {'title':search_term} where
#     search_term is a string from a form field.
#
#    you'd invoke this as: 
#    xSearch([{ 'text_content':search_term},{'title':search_term}],{meta_type:'someMetaType',spam:'eggs'},50,'off')
#    
##################################################################################

def xSearch(self, variant, invariant, numResults, moderated):
	objList = []                        #empty result list
	for var in variant:
		argList = {}                   #ensure emptiness
		argList.update(var)            #this should be a single key:value pair
		argList.update(invariant)      #add the invariant dictionary     

		results = self.Catalog.searchResults(argList)	#get results for this iteration.

		#scan thru results and add result OBJECTS (not the data_record_id_) to the object list
		for item in results:	#loop thru the results
			obj = self.Catalog.getobject(item.data_record_id_)	#get the object from the result item (an EventDoc)
			flag = '0'  		

			for thing in objList:	        	#if this EventDoc isn't already in the list
				if thing.id == obj.id:
					flag = '1'
					break
			if flag == '0':
				#If moderated == 'on' we have to chk the parent obj (the event doc) to see if it has the reviewed property == on
				if moderated == 'on':
					if obj.reviewed == 'on':
						objList.append(obj)		#if moderated and this was reviewed, add it
				else:
					objList.append(obj)		#else always append it.
	return objList